<?php

namespace Tests\Feature\Http\Controllers;

use App\Models\Categoria;
use App\Models\Producto;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Foundation\Testing\WithFaker;
use JMac\Testing\Traits\AdditionalAssertions;
use PHPUnit\Framework\Attributes\Test;
use Tests\TestCase;

/**
 * @see \App\Http\Controllers\ProductoController
 */
final class ProductoControllerTest extends TestCase
{
    use AdditionalAssertions, RefreshDatabase, WithFaker;

    #[Test]
    public function index_behaves_as_expected(): void
    {
        $productos = Producto::factory()->count(3)->create();

        $response = $this->get(route('productos.index'));

        $response->assertOk();
        $response->assertJsonStructure([]);
    }


    #[Test]
    public function store_uses_form_request_validation(): void
    {
        $this->assertActionUsesFormRequest(
            \App\Http\Controllers\ProductoController::class,
            'store',
            \App\Http\Requests\ProductoStoreRequest::class
        );
    }

    #[Test]
    public function store_saves(): void
    {
        $nombre = fake()->word();
        $codigo_barras = fake()->word();
        $precio_compra = fake()->randomFloat(/** decimal_attributes **/);
        $precio_venta = fake()->randomFloat(/** decimal_attributes **/);
        $stock = fake()->numberBetween(-10000, 10000);
        $categoria = Categoria::factory()->create();
        $estado = fake()->randomElement(/** enum_attributes **/);

        $response = $this->post(route('productos.store'), [
            'nombre' => $nombre,
            'codigo_barras' => $codigo_barras,
            'precio_compra' => $precio_compra,
            'precio_venta' => $precio_venta,
            'stock' => $stock,
            'categoria_id' => $categoria->id,
            'estado' => $estado,
        ]);

        $productos = Producto::query()
            ->where('nombre', $nombre)
            ->where('codigo_barras', $codigo_barras)
            ->where('precio_compra', $precio_compra)
            ->where('precio_venta', $precio_venta)
            ->where('stock', $stock)
            ->where('categoria_id', $categoria->id)
            ->where('estado', $estado)
            ->get();
        $this->assertCount(1, $productos);
        $producto = $productos->first();

        $response->assertCreated();
        $response->assertJsonStructure([]);
    }


    #[Test]
    public function show_behaves_as_expected(): void
    {
        $producto = Producto::factory()->create();

        $response = $this->get(route('productos.show', $producto));

        $response->assertOk();
        $response->assertJsonStructure([]);
    }


    #[Test]
    public function update_uses_form_request_validation(): void
    {
        $this->assertActionUsesFormRequest(
            \App\Http\Controllers\ProductoController::class,
            'update',
            \App\Http\Requests\ProductoUpdateRequest::class
        );
    }

    #[Test]
    public function update_behaves_as_expected(): void
    {
        $producto = Producto::factory()->create();
        $nombre = fake()->word();
        $codigo_barras = fake()->word();
        $precio_compra = fake()->randomFloat(/** decimal_attributes **/);
        $precio_venta = fake()->randomFloat(/** decimal_attributes **/);
        $stock = fake()->numberBetween(-10000, 10000);
        $categoria = Categoria::factory()->create();
        $estado = fake()->randomElement(/** enum_attributes **/);

        $response = $this->put(route('productos.update', $producto), [
            'nombre' => $nombre,
            'codigo_barras' => $codigo_barras,
            'precio_compra' => $precio_compra,
            'precio_venta' => $precio_venta,
            'stock' => $stock,
            'categoria_id' => $categoria->id,
            'estado' => $estado,
        ]);

        $producto->refresh();

        $response->assertOk();
        $response->assertJsonStructure([]);

        $this->assertEquals($nombre, $producto->nombre);
        $this->assertEquals($codigo_barras, $producto->codigo_barras);
        $this->assertEquals($precio_compra, $producto->precio_compra);
        $this->assertEquals($precio_venta, $producto->precio_venta);
        $this->assertEquals($stock, $producto->stock);
        $this->assertEquals($categoria->id, $producto->categoria_id);
        $this->assertEquals($estado, $producto->estado);
    }


    #[Test]
    public function destroy_deletes_and_responds_with(): void
    {
        $producto = Producto::factory()->create();

        $response = $this->delete(route('productos.destroy', $producto));

        $response->assertNoContent();

        $this->assertModelMissing($producto);
    }
}
